#
# SevoMod  (by Sevo, duh!)
# CvSevoEventManager
# 

from CvPythonExtensions import *
import CvUtil

import CvEventManager
import sys
import PyHelpers
import CvCameraControls

import SevoMod
import RandomNameUtils
import CvGDEventManager
import CvFieldHospitalEventManager

gc = CyGlobalContext()	

cd = SevoMod.CulturalDecay()
rf = SevoMod.RealFort()
tc = SevoMod.TechConquest()
Forest = SevoMod.NewForest()
ancient = SevoMod.AncientTemple()
SevoTraits = SevoMod.SevoTraits()
jungleBurn = SevoMod.JungleBurner()
realSlavery = SevoMod.RealSlavery()

CMI = CvEventManager.CvScreensInterface.CvMainInterface


PyPlayer = PyHelpers.PyPlayer

# globals
###################################################
class CvSevoEventManager(CvEventManager.CvEventManager):
	def __init__(self):
		# initialize base class
		self.parent = CvEventManager.CvEventManager
		self.parent.__init__(self)

	def onUnitCreated(self, argsList):
		'Unit Completed'
		unit = argsList[0]
		player = PyPlayer(unit.getOwner())
		SevoTraits.checkNewUnit(argsList[0],false)

		self.parent.onUnitCreated(self, argsList)
		iOwner = gc.getPlayer(unit.getOwner())
		iCivilizationType = iOwner.getCivilizationType()
		unit.setName(RandomNameUtils.getRandomCivilizationName(iCivilizationType))

	def onBeginGameTurn(self, argsList):
		iGameTurn = argsList[0]
		
		# I am intentionally NOT going to parent onBeginGameTurn
		# The CvTopCivs popup screen is generating errors b/c of a random num generator prob.
		# That is the only other function called, so screw it.
		#self.parent.onBeginGameTurn(self, argsList)

	def onUnitMove(self, argsList):
		rf.onUnitMove(argsList)
		SevoTraits.onUnitMove(argsList)
		self.parent.onUnitMove(self, argsList)
		
	def onLoadGame(self, argsList):
		self.parent.onLoadGame(self, argsList)
		
		# Gotta reload all the __init__ variables in the system!
		SevoTraits.__init__()
	
	def onGameStart(self, argsList):
		CMI.CvMainInterface.pOldPlot = 0
		self.parent.onGameStart(self, argsList)
	
	def onTechAcquired(self, argsList):
		rf.onTechAcquired(argsList)
		#tw.onTechAcquired(argsList)
		self.parent.onTechAcquired(self, argsList)

	def onCityGrowth(self, argsList):
		SevoTraits.checkCityForTrait(argsList[0])
		self.parent.onCityGrowth(self,argsList)
		
	def onCityAcquired(self, argsList):
		tc.onCityAcquired(argsList)
		SevoTraits.checkCityForTrait(argsList[2])
		self.parent.onCityAcquired(self, argsList)
		
	def onCityBuilt(self, argsList):
		if (gc.getGame().getElapsedGameTurns() < 11) :
			jungleBurn.onCityBuilt(argsList)
		self.parent.onCityBuilt(self, argsList)	

	def onEndGameTurn(self, argsList):
		cd.onEndGameTurn(argsList)
		Forest.updateAllPlots()
		self.parent.onEndGameTurn(self, argsList)

	def onBeginPlayerTurn(self, argsList):
		self.parent.onBeginPlayerTurn(self, argsList)
		
	def onEndPlayerTurn(self, argsList):
		iGameTurn, iPlayer = argsList
		realSlavery.onEndPlayerTurn(argsList)
		self.parent.onEndPlayerTurn
		

	def onImprovementBuilt(self, argsList):
		rf.onImprovementBuilt(argsList)
		#nf.onImprovementBuilt(argsList)
		ancient.onImprovementBuilt(argsList)	
		self.parent.onImprovementBuilt(self, argsList)

	def onUnitBuilt(self, argsList):
		'Unit Completed'
		self.parent.onUnitCreated(self, argsList)

		city = argsList[0]
		unit = argsList[1]
		unit.setName(RandomNameUtils.getRandomName())

	def onUnitPromoted(self,argsList):
		self.parent.onUnitPromoted(self, argsList)
		
	def onUnitCreated(self, argsList):
		unit = argsList[0]
		player = PyPlayer(unit.getOwner())
		SevoTraits.checkNewUnit(argsList[0],false)
		self.parent.onUnitCreated(self,argsList)
		
	def onCombatResult(self, argsList):
		realSlavery.onCombatResult(argsList)
		self.parent.onCombatResult(self, argsList)
		